diff -r f3e24bd4d57e trytond/modules/sale/sale.py
--- a/trytond/modules/sale/sale.py	Tue Sep 11 15:23:08 2012 +0200
+++ b/trytond/modules/sale/sale.py	Mon Sep 24 20:36:42 2012 +0200
@@ -1,6 +1,5 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
-import copy
 from decimal import Decimal
 import datetime
 from itertools import groupby
@@ -12,16 +11,23 @@
 from trytond.backend import TableHandler
 from trytond.pyson import If, Eval, Bool, PYSONEncoder, Id
 from trytond.transaction import Transaction
-from trytond.pool import Pool
+from trytond.pool import Pool, PoolMeta
 from trytond.config import CONFIG
 
+__all__ = ['Sale', 'SaleInvoice', 'SaleIgnoredInvoice', 'SaleRecreatedInvoice',
+    'SaleLine', 'SaleLineTax', 'SaleLineInvoiceLine', 'SaleLineIgnoredMove',
+    'SaleLineRecreatedMove', 'SaleReport', 'Template', 'Product',
+    'ShipmentOut', 'ShipmentOutReturn', 'Move', 'OpenCustomer',
+    'HandleShipmentExceptionAsk', 'HandleShipmentException',
+    'HandleInvoiceExceptionAsk', 'HandleInvoiceException',
+    'ReturnSale']
+__metaclass__ = PoolMeta
+
 
 class Sale(Workflow, ModelSQL, ModelView):
     'Sale'
-    _name = 'sale.sale'
+    __name__ = 'sale.sale'
     _rec_name = 'reference'
-    _description = __doc__
-
     company = fields.Many2One('company.company', 'Company', required=True,
         states={
             'readonly': (Eval('state') != 'draft') | Eval('lines', [0]),
@@ -62,7 +68,7 @@
             }, on_change=['party', 'payment_term'],
         depends=['state'])
     party_lang = fields.Function(fields.Char('Party Language',
-        on_change_with=['party']), 'get_function_fields')
+            on_change_with=['party']), 'on_change_with_party_lang')
     invoice_address = fields.Many2One('party.address', 'Invoice Address',
         domain=[('party', '=', Eval('party'))], states={
             'readonly': Eval('state') != 'draft',
@@ -84,7 +90,7 @@
             },
         depends=['state'])
     currency_digits = fields.Function(fields.Integer('Currency Digits',
-        on_change_with=['currency']), 'get_function_fields')
+            on_change_with=['currency']), 'on_change_with_currency_digits')
     lines = fields.One2Many('sale.line', 'sale', 'Lines', states={
             'readonly': Eval('state') != 'draft',
             }, on_change=['lines', 'currency', 'party'],
@@ -154,26 +160,28 @@
         fields.One2Many('stock.shipment.out.return', None, 'Shipment Returns'),
         'get_shipment_returns')
     moves = fields.Function(fields.One2Many('stock.move', None, 'Moves'),
-            'get_function_fields')
+        'get_moves')
 
-    def __init__(self):
-        super(Sale, self).__init__()
-        self._order.insert(0, ('sale_date', 'DESC'))
-        self._order.insert(1, ('id', 'DESC'))
-        self._constraints += [
+    @classmethod
+    def __setup__(cls):
+        super(Sale, cls).__setup__()
+        cls._order.insert(0, ('sale_date', 'DESC'))
+        cls._order.insert(1, ('id', 'DESC'))
+        cls._constraints += [
             ('check_method', 'wrong_method')
-        ]
-        self._error_messages.update({
-            'wrong_method': 'Wrong combination of method!',
-            'addresses_required': 'Invoice and Shipment addresses must be '
-            'defined for the quotation.',
-            'warehouse_required': 'Warehouse must be defined for the ' \
-                'quotation.',
-            'missing_account_receivable': 'It misses '
-                    'an "Account Receivable" on the party "%s"!',
-            'delete_cancel': 'Sale "%s" must be cancelled before deletion!',
-        })
-        self._transitions |= set((
+            ]
+        cls._error_messages.update({
+                'wrong_method': 'Wrong combination of method!',
+                'addresses_required': 'Invoice and Shipment addresses must be '
+                'defined for the quotation.',
+                'warehouse_required': 'Warehouse must be defined for the ' \
+                    'quotation.',
+                'missing_account_receivable': 'It misses '
+                'an "Account Receivable" on the party "%s"!',
+                'delete_cancel': 'Sale "%s" must be cancelled ' \
+                    'before deletion!',
+                })
+        cls._transitions |= set((
                 ('draft', 'quotation'),
                 ('quotation', 'confirmed'),
                 ('confirmed', 'processing'),
@@ -183,7 +191,7 @@
                 ('quotation', 'draft'),
                 ('cancel', 'draft'),
                 ))
-        self._buttons.update({
+        cls._buttons.update({
                 'cancel': {
                     'invisible': ~Eval('state').in_(['draft', 'quotation']),
                     },
@@ -216,13 +224,14 @@
                     },
                 })
         # The states where amounts are cached
-        self._states_cached = ['confirmed', 'processing', 'done', 'cancel']
+        cls._states_cached = ['confirmed', 'processing', 'done', 'cancel']
 
-    def init(self, module_name):
+    @classmethod
+    def __register__(cls, module_name):
         pool = Pool()
-        sale_line_obj = pool.get('sale.line')
-        sale_line_invoice_line_obj = pool.get('sale.line-account.invoice.line')
-        move_obj = pool.get('stock.move')
+        SaleLine = pool.get('sale.line')
+        SaleLine_InvoiceLine = pool.get('sale.line-account.invoice.line')
+        Move = pool.get('stock.move')
         cursor = Transaction().cursor
         # Migration from 1.2: packing renamed into shipment
         cursor.execute("UPDATE ir_model_data "
@@ -235,27 +244,27 @@
                 "WHERE (relation like '%%packing%%' "
                     "OR name like '%%packing%%') AND module = %s",
                 (module_name,))
-        table = TableHandler(cursor, self, module_name)
+        table = TableHandler(cursor, cls, module_name)
         table.column_rename('packing_state', 'shipment_state')
         table.column_rename('packing_method', 'shipment_method')
         table.column_rename('packing_address', 'shipment_address')
 
-        super(Sale, self).init(module_name)
+        super(Sale, cls).__register__(module_name)
 
         # Migration from 1.2
-        cursor.execute("UPDATE " + self._table + " "
+        cursor.execute("UPDATE " + cls._table + " "
                 "SET invoice_method = 'shipment' "
                 "WHERE invoice_method = 'packing'")
 
-        table = TableHandler(cursor, self, module_name)
+        table = TableHandler(cursor, cls, module_name)
         # Migration from 2.2
         table.not_null_action('sale_date', 'remove')
 
         # state confirmed splitted into confirmed and processing
-        if (TableHandler.table_exist(cursor, sale_line_obj._table)
+        if (TableHandler.table_exist(cursor, SaleLine._table)
                 and TableHandler.table_exist(cursor,
-                    sale_line_invoice_line_obj._table)
-                and TableHandler.table_exist(cursor, move_obj._table)):
+                    SaleLine_InvoiceLine._table)
+                and TableHandler.table_exist(cursor, Move._table)):
             # Wrap subquery inside an other inner subquery because MySQL syntax
             # doesn't allow update a table and select from the same table in a
             # subquery.
@@ -272,290 +281,201 @@
                         "WHERE s.state = 'confirmed' "
                             'AND (li.id IS NOT NULL '
                                 'OR m.id IS NOT NULL)) AS foo)'
-                % (self._table, self._table, sale_line_obj._table,
-                    sale_line_invoice_line_obj._table, move_obj._table))
+                % (cls._table, cls._table, SaleLine._table,
+                    SaleLine_InvoiceLine._table, Move._table))
 
         # Add index on create_date
-        table = TableHandler(cursor, self, module_name)
+        table = TableHandler(cursor, cls, module_name)
         table.index_action('create_date', action='add')
 
-    def default_payment_term(self):
-        payment_term_obj = Pool().get('account.invoice.payment_term')
-        payment_term_ids = payment_term_obj.search(self.payment_term.domain)
-        if len(payment_term_ids) == 1:
-            return payment_term_ids[0]
+    @classmethod
+    def default_payment_term(cls):
+        PaymentTerm = Pool().get('account.invoice.payment_term')
+        payment_terms = PaymentTerm.search(cls.payment_term.domain)
+        if len(payment_terms) == 1:
+            return payment_terms[0].id
 
-    def default_warehouse(self):
-        location_obj = Pool().get('stock.location')
-        location_ids = location_obj.search(self.warehouse.domain)
-        if len(location_ids) == 1:
-            return location_ids[0]
+    @classmethod
+    def default_warehouse(cls):
+        Location = Pool().get('stock.location')
+        locations = Location.search(cls.warehouse.domain)
+        if len(locations) == 1:
+            return locations[0].id
 
-    def default_company(self):
+    @staticmethod
+    def default_company():
         return Transaction().context.get('company')
 
-    def default_state(self):
+    @staticmethod
+    def default_state():
         return 'draft'
 
-    def default_currency(self):
-        company_obj = Pool().get('company.company')
+    @staticmethod
+    def default_currency():
+        Company = Pool().get('company.company')
         company = Transaction().context.get('company')
         if company:
-            return company_obj.browse(company).currency.id
+            return Company(company).currency.id
 
-    def default_currency_digits(self):
-        company_obj = Pool().get('company.company')
+    @staticmethod
+    def default_currency_digits():
+        Company = Pool().get('company.company')
         company = Transaction().context.get('company')
         if company:
-            return company_obj.browse(company).currency.digits
+            return Company(company).currency.digits
         return 2
 
-    def default_invoice_method(self):
-        config_obj = Pool().get('sale.configuration')
-        config = config_obj.browse(1)
+    @staticmethod
+    def default_invoice_method():
+        Config = Pool().get('sale.configuration')
+        config = Config(1)
         return config.sale_invoice_method
 
-    def default_invoice_state(self):
+    @staticmethod
+    def default_invoice_state():
         return 'none'
 
-    def default_shipment_method(self):
-        config_obj = Pool().get('sale.configuration')
-        config = config_obj.browse(1)
+    @staticmethod
+    def default_shipment_method():
+        Config = Pool().get('sale.configuration')
+        config = Config(1)
         return config.sale_shipment_method
 
-    def default_shipment_state(self):
+    @staticmethod
+    def default_shipment_state():
         return 'none'
 
-    def on_change_party(self, vals):
-        pool = Pool()
-        party_obj = pool.get('party.party')
-        address_obj = pool.get('party.address')
-        payment_term_obj = pool.get('account.invoice.payment_term')
-        res = {
-            'invoice_address': None,
-            'shipment_address': None,
-            'payment_term': None,
-        }
-        if vals.get('party'):
-            party = party_obj.browse(vals['party'])
-            res['invoice_address'] = party_obj.address_get(party.id,
-                    type='invoice')
-            res['shipment_address'] = party_obj.address_get(party.id,
-                    type='delivery')
-            if party.customer_payment_term:
-                res['payment_term'] = party.customer_payment_term.id
+    def on_change_party(self):
+        invoice_address = None
+        shipment_address = None
+        payment_term = None
+        if self.party:
+            invoice_address = self.party.address_get(type='invoice')
+            shipment_address = self.party.address_get(type='delivery')
+            if self.party.customer_payment_term:
+                payment_term = self.party.customer_payment_term
 
-        if res['invoice_address']:
-            res['invoice_address.rec_name'] = address_obj.browse(
-                    res['invoice_address']).rec_name
-        if res['shipment_address']:
-            res['shipment_address.rec_name'] = address_obj.browse(
-                    res['shipment_address']).rec_name
-        if not res['payment_term']:
-            res['payment_term'] = self.default_payment_term()
-        if res['payment_term']:
-            res['payment_term.rec_name'] = payment_term_obj.browse(
-                    res['payment_term']).rec_name
+        changes = {}
+        if invoice_address:
+            changes['invoice_address'] = invoice_address.id
+            changes['invoice_address.rec_name'] = invoice_address.rec_name
+        else:
+            changes['invoice_address'] = None
+        if shipment_address:
+            changes['shipment_address'] = shipment_address.id
+            changes['shipment_address.rec_name'] = shipment_address.rec_name
+        else:
+            changes['shipment_address'] = None
+        if payment_term:
+            changes['payment_term'] = payment_term.id
+            changes['payment_term.rec_name'] = payment_term.rec_name
+        else:
+            changes['payment_term'] = self.default_payment_term()
+        return changes
+
+    def on_change_with_currency_digits(self, name=None):
+        if self.currency:
+            return self.currency.digits
+        return 2
+
+    def get_tax_context(self):
+        res = {}
+        if self.party and self.party.lang:
+            res['language'] = self.party.lang.code
         return res
 
-    def on_change_with_currency_digits(self, vals):
-        currency_obj = Pool().get('currency.currency')
-        if vals.get('currency'):
-            currency = currency_obj.browse(vals['currency'])
-            return currency.digits
-        return 2
-
-    def get_currency_digits(self, sales):
-        '''
-        Return the number of digits of the currency of each sales
-
-        :param sales: a BrowseRecordList of puchases
-        :return: a dictionary with sale id as key and
-            number of digits as value
-        '''
-        res = {}
-        for sale in sales:
-            res[sale.id] = sale.currency.digits
-        return res
-
-    def get_tax_context(self, sale):
-        party_obj = Pool().get('party.party')
-        res = {}
-        if isinstance(sale, dict):
-            if sale.get('party'):
-                party = party_obj.browse(sale['party'])
-                if party.lang:
-                    res['language'] = party.lang.code
-        else:
-            if sale.party.lang:
-                res['language'] = sale.party.lang.code
-        return res
-
-    def on_change_with_party_lang(self, vals):
-        party_obj = Pool().get('party.party')
-        if vals.get('party'):
-            party = party_obj.browse(vals['party'])
-            if party.lang:
-                return party.lang.code
+    def on_change_with_party_lang(self, name=None):
+        if self.party and self.party.lang:
+            return self.party.lang.code
         return CONFIG['language']
 
-    def get_party_lang(self, sales):
-        '''
-        Return the code lang of the party for each sales
-
-        :param sales: a BrowseRecordList of sales
-        :return: a dictionary with sale id as key and
-            code lang as value
-        '''
-        res = {}
-        for sale in sales:
-            if sale.party.lang:
-                res[sale.id] = sale.party.lang.code
-            else:
-                res[sale.id] = CONFIG['language']
-        return res
-
-    def on_change_lines(self, vals):
+    def on_change_lines(self):
         pool = Pool()
-        currency_obj = pool.get('currency.currency')
-        tax_obj = pool.get('account.tax')
-        invoice_obj = pool.get('account.invoice')
+        Tax = pool.get('account.tax')
+        Invoice = pool.get('account.invoice')
 
         res = {
             'untaxed_amount': Decimal('0.0'),
             'tax_amount': Decimal('0.0'),
             'total_amount': Decimal('0.0'),
-        }
+            }
 
-        currency = None
-        if vals.get('currency'):
-            currency = currency_obj.browse(vals['currency'])
-
-        if vals.get('lines'):
+        if self.lines:
             taxes = {}
-            for line in vals['lines']:
-                if line.get('type', 'line') != 'line':
+            for line in self.lines:
+                if getattr(line, 'type', 'line') != 'line':
                     continue
-                res['untaxed_amount'] += line.get('amount') or Decimal(0)
+                res['untaxed_amount'] += line.amount or Decimal(0)
                 tax_list = ()
-                with Transaction().set_context(self.get_tax_context(vals)):
-                    tax_list = tax_obj.compute(line.get('taxes', []),
-                            line.get('unit_price') or Decimal('0.0'),
-                            line.get('quantity') or 0.0)
+                with Transaction().set_context(self.get_tax_context()):
+                    tax_list = Tax.compute(getattr(line, 'taxes', []),
+                        line.unit_price or Decimal('0.0'),
+                        line.quantity or 0.0)
                 for tax in tax_list:
-                    key, val = invoice_obj._compute_tax(tax, 'out_invoice')
+                    key, val = Invoice._compute_tax(tax, 'out_invoice')
                     if not key in taxes:
                         taxes[key] = val['amount']
                     else:
                         taxes[key] += val['amount']
-            if currency:
+            if self.currency:
                 for key in taxes:
-                    res['tax_amount'] += currency_obj.round(currency,
-                            taxes[key])
-        if currency:
-            res['untaxed_amount'] = currency_obj.round(currency,
-                    res['untaxed_amount'])
-            res['tax_amount'] = currency_obj.round(currency,
-                    res['tax_amount'])
+                    res['tax_amount'] += self.currency.round(taxes[key])
+        if self.currency:
+            res['untaxed_amount'] = self.currency.round(res['untaxed_amount'])
+            res['tax_amount'] = self.currency.round(res['tax_amount'])
         res['total_amount'] = res['untaxed_amount'] + res['tax_amount']
-        if currency:
-            res['total_amount'] = currency_obj.round(currency,
-                    res['total_amount'])
+        if self.currency:
+            res['total_amount'] = self.currency.round(res['total_amount'])
         return res
 
-    def get_function_fields(self, ids, names):
-        '''
-        Function to compute function fields for sale ids
+    def get_untaxed_amount(self, name):
+        if (self.state in self._states_cached
+                and self.untaxed_amount_cache is not None):
+            return self.untaxed_amount_cache
+        amount = sum((l.amount for l in self.lines if l.type == 'line'),
+            Decimal(0))
+        return self.currency.round(amount)
 
-        :param ids: the ids of the sales
-        :param names: the list of field name to compute
-        :return: a dictionary with all field names as key and
-            a dictionary as value with id as key
-        '''
-        res = {}
-        sales = self.browse(ids)
-        if 'currency_digits' in names:
-            res['currency_digits'] = self.get_currency_digits(sales)
-        if 'party_lang' in names:
-            res['party_lang'] = self.get_party_lang(sales)
-        if 'moves' in names:
-            res['moves'] = self.get_moves(sales)
-        return res
+    def get_tax_amount(self, name):
+        pool = Pool()
+        Tax = pool.get('account.tax')
+        Invoice = pool.get('account.invoice')
 
-    def get_untaxed_amount(self, ids, name):
-        '''
-        Compute the untaxed amount for each sales
-        '''
-        currency_obj = Pool().get('currency.currency')
-        amounts = {}
-        for sale in self.browse(ids):
-            if (sale.state in self._states_cached
-                    and sale.untaxed_amount_cache is not None):
-                amounts[sale.id] = sale.untaxed_amount_cache
+        if (self.state in self._states_cached
+                and self.tax_amount_cache is not None):
+            return self.tax_amount_cache
+        context = self.get_tax_context()
+        taxes = {}
+        for line in self.lines:
+            if line.type != 'line':
                 continue
-            amount = sum((l.amount for l in sale.lines if l.type == 'line'),
-                Decimal(0))
-            amounts[sale.id] = currency_obj.round(sale.currency, amount)
-        return amounts
+            with Transaction().set_context(context):
+                tax_list = Tax.compute(line.taxes, line.unit_price,
+                    line.quantity)
+            # Don't round on each line to handle rounding error
+            for tax in tax_list:
+                key, val = Invoice._compute_tax(tax, 'out_invoice')
+                if not key in taxes:
+                    taxes[key] = val['amount']
+                else:
+                    taxes[key] += val['amount']
+        amount = sum((self.currency.round(taxes[key]) for key in taxes),
+            Decimal(0))
+        return self.currency.round(amount)
 
-    def get_tax_amount(self, ids, name):
-        '''
-        Compute tax amount for each sales
-        '''
-        pool = Pool()
-        currency_obj = pool.get('currency.currency')
-        tax_obj = pool.get('account.tax')
-        invoice_obj = pool.get('account.invoice')
+    def get_total_amount(self, name):
+        if (self.state in self._states_cached
+                and self.total_amount_cache is not None):
+            return self.total_amount_cache
+        return self.currency.round(self.untaxed_amount + self.tax_amount)
 
-        amounts = {}
-        for sale in self.browse(ids):
-            if (sale.state in self._states_cached
-                    and sale.tax_amount_cache is not None):
-                amounts[sale.id] = sale.tax_amount_cache
-                continue
-            context = self.get_tax_context(sale)
-            taxes = {}
-            for line in sale.lines:
-                if line.type != 'line':
-                    continue
-                with Transaction().set_context(context):
-                    tax_list = tax_obj.compute(
-                            [t.id for t in line.taxes], line.unit_price,
-                            line.quantity)
-                # Don't round on each line to handle rounding error
-                for tax in tax_list:
-                    key, val = invoice_obj._compute_tax(tax, 'out_invoice')
-                    if not key in taxes:
-                        taxes[key] = val['amount']
-                    else:
-                        taxes[key] += val['amount']
-            amount = sum((currency_obj.round(sale.currency, taxes[key])
-                    for key in taxes), Decimal(0))
-            amounts[sale.id] = currency_obj.round(sale.currency, amount)
-        return amounts
-
-    def get_total_amount(self, ids, name):
-        '''
-        Return the total amount of each sales
-        '''
-        currency_obj = Pool().get('currency.currency')
-        amounts = {}
-        for sale in self.browse(ids):
-            if (sale.state in self._states_cached
-                    and sale.total_amount_cache is not None):
-                amounts[sale.id] = sale.total_amount_cache
-                continue
-            amounts[sale.id] = currency_obj.round(sale.currency,
-                sale.untaxed_amount + sale.tax_amount)
-        return amounts
-
-    def get_invoice_state(self, sale):
+    def get_invoice_state(self):
         '''
         Return the invoice state for the sale.
         '''
-        skip_ids = set(x.id for x in sale.invoices_ignored)
-        skip_ids.update(x.id for x in sale.invoices_recreated)
-        invoices = [i for i in sale.invoices if i.id not in skip_ids]
+        skip_ids = set(x.id for x in self.invoices_ignored)
+        skip_ids.update(x.id for x in self.invoices_recreated)
+        invoices = [i for i in self.invoices if i.id not in skip_ids]
         if invoices:
             if any(i.state == 'cancel' for i in invoices):
                 return 'exception'
@@ -565,102 +485,84 @@
                 return 'waiting'
         return 'none'
 
-    def set_invoice_state(self, sale):
+    def set_invoice_state(self):
         '''
         Set the invoice state.
         '''
-        state = self.get_invoice_state(sale)
-        if sale.invoice_state != state:
-            self.write(sale.id, {
+        state = self.get_invoice_state()
+        if self.invoice_state != state:
+            self.write([self], {
                     'invoice_state': state,
                     })
 
     def get_shipments_returns(attribute):
         "Computes the returns or shipments"
-        def method(self, ids, name):
-            shipments = {}
-            for sale in self.browse(ids):
-                shipments[sale.id] = []
-                for line in sale.lines:
-                    for move in line.moves:
-                        ship_or_return = getattr(move, attribute)
-                        if bool(ship_or_return):
-                            if ship_or_return.id not in shipments[sale.id]:
-                                shipments[sale.id].append(ship_or_return.id)
+        def method(self, name):
+            shipments = []
+            for line in self.lines:
+                for move in line.moves:
+                    ship_or_return = getattr(move, attribute)
+                    if bool(ship_or_return):
+                        if ship_or_return.id not in shipments:
+                            shipments.append(ship_or_return.id)
             return shipments
         return method
 
     get_shipments = get_shipments_returns('shipment_out')
     get_shipment_returns = get_shipments_returns('shipment_out_return')
 
-    def get_moves(self, sales):
-        '''
-        Return move ids for each sales
+    def get_moves(self, name):
+        return [m.id for l in self.lines for m in l.moves]
 
-        :param sales: a BrowseRecordList of sales
-        :return: a dictionary with sale id as key and
-            a list of move ids as value
-        '''
-        res = {}
-        for sale in sales:
-            res[sale.id] = []
-            for line in sale.lines:
-                res[sale.id].extend([x.id for x in line.moves])
-        return res
-
-    def get_shipment_state(self, sale):
+    def get_shipment_state(self):
         '''
         Return the shipment state for the sale.
         '''
-        if sale.moves:
-            if any(l.move_exception for l in sale.lines):
+        if self.moves:
+            if any(l.move_exception for l in self.lines):
                 return 'exception'
-            elif all(l.move_done for l in sale.lines):
+            elif all(l.move_done for l in self.lines):
                 return 'sent'
             else:
                 return 'waiting'
         return 'none'
 
-    def set_shipment_state(self, sale):
+    def set_shipment_state(self):
         '''
         Set the shipment state.
         '''
-        state = self.get_shipment_state(sale)
-        if sale.shipment_state != state:
-            self.write(sale.id, {
+        state = self.get_shipment_state()
+        if self.shipment_state != state:
+            self.write([self], {
                     'shipment_state': state,
                     })
 
-    def check_method(self, ids):
+    def check_method(self):
         '''
         Check the methods.
         '''
-        for sale in self.browse(ids):
-            if sale.invoice_method == 'shipment' \
-                    and sale.shipment_method in ('invoice', 'manual'):
-                return False
-            if sale.shipment_method == 'invoice' \
-                    and sale.invoice_method in ('shipment', 'manual'):
-                return False
+        if (self.invoice_method == 'shipment'
+                and self.shipment_method in ('invoice', 'manual')):
+            return False
+        if (self.shipment_method == 'invoice'
+                and self.invoice_method in ('shipment', 'manual')):
+            return False
         return True
 
-    def get_rec_name(self, ids, name):
-        if not ids:
-            return []
-        res = {}
-        for sale in self.browse(ids):
-            res[sale.id] = sale.reference or str(sale.id) \
-                    + ' - ' + sale.party.rec_name
-        return res
+    def get_rec_name(self, name):
+        return (self.reference or str(self.id)
+            + ' - ' + self.party.rec_name)
 
-    def search_rec_name(self, name, clause):
+    @classmethod
+    def search_rec_name(cls, name, clause):
         names = clause[2].split(' - ', 1)
         res = [('reference', clause[1], names[0])]
         if len(names) != 1 and names[1]:
             res.append(('party', clause[1], names[1]))
         return res
 
-    def copy(self, ids, default=None):
+    @classmethod
+    def copy(cls, sales, default=None):
         if default is None:
             default = {}
         default = default.copy()
